// This is the main project file for VC++ application project 
// generated using an Application Wizard.

#include "stdafx.h"
#include "glui.h"
#include "TrackBall.h"
#include "MyPoint.h"
#include "Diplomski.h"
// #include "AviGenerator.h"


#using <mscorlib.dll>

#pragma comment( linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"" )  
//gornji koment da ne bi bilo konzol vindoua

#pragma comment (lib, "GLui32.lib")
//#pragma comment (lib, "GLut32.lib")
//#pragma comment (lib, "GLu32.lib")
//#pragma comment (lib, "OpenGL32.lib")

#define		OFF		0
#define		ON		1

#define		MOUSE_CLEAR				0
#define		MOUSE_LEFT_BUTTON_DOWN	1
#define		MOUSE_RIGHT_BUTTON_DOWN	2

#define		SHADE_NONE				0
#define		SHADE_FLAT				1
#define		SHADE_SMOOTH			2

#define		BUFSIZE					10240 //velicina buffera za picking
#define		RENDER					1
#define		SELECT					2

#define		MAX_N_TRAIN					100 //maksimalan broj tocaka za training
#define LAMBDA						0//regulacijski parametar
#define RBFCONST					1024

#define CIL_KOEF					2.0	//koeficijent kod cilindricne projekcije

#define		FAZE					5 // trenutni broj faza

using namespace System;

GLint glutWnd1;
GLUI *gluiWnd1 = NULL;	//pointer za GLUI prozor

//boje za iscrtavanje
GLfloat red = 1.00f;
GLfloat green = 0.75f;
GLfloat blue = 0.65f;

GLfloat yodared = 0.564706f;
GLfloat yodagreen = 0.623529f;
GLfloat yodablue = 0.298039f;


GLfloat AmbientLight[] = { 0.5f, 0.5f, 0.5f, 1.0f };
GLfloat DiffuseLight[] = { 1.0f, 1.0f, 1.0f, 1.0f };
GLfloat LightPosition[] = { 0.0, -1.5, -1.5, 1.0 };

GLubyte wireframe = 0;
GLubyte reset = 0;
GLubyte shade = SHADE_NONE;

GLfloat  zoom = -45.0f; //za zoomiranje

//strukture za ucitavanje mesha
GLint nVertex;		//broj verteksa u meshu
GLint nTriangles;	//broj trokuta
GLint nVertex1;
GLint nTriangles1;
GLint nVertex2;
GLint nTriangles2;
GLint nVertex3;
GLint nTriangles3;
GLint nVertex4;
GLint nTriangles4;

GLint w, h;

//varijable za implementaciju trackballa
TrackBall m_trackBall;
Point2i m_prerotMouse, m_rotMouse;
Point2i m_clientWindow;
GLint mouseState = MOUSE_CLEAR;

//varijable za ekranske koordinate misa za picking
GLint cursorX, cursorY;
GLuint selectBuf[BUFSIZE];
GLint hits;
GLint renderMode = RENDER;


Point normalX; //pomocna normala


//vertexi selektirani pickingom na 4 izraza lica
Point selVertex1[10000];
GLint selVertexIndex1 = -1;
GLint selPointsIndex1[10000];

Point selVertex2[10000];
GLint selVertexIndex2 = -1;
GLint selPointsIndex2[10000];

Point selVertex3[10000];
GLint selVertexIndex3 = -1;
GLint selPointsIndex3[10000];

Point selVertex4[10000];
GLint selVertexIndex4 = -1;
GLint selPointsIndex4[10000];



int	selWeights1[10000];
int	selWeights2[10000];
int	selWeights3[10000];
int	selWeights4[10000];

int zadnji1 = 0;
int zadnji2 = 0;
int zadnji3 = 0;
int zadnji4 = 0;

long index1 = 0;
long index2 = 0;
long index3 = 0;
long index4 = 0;

int pickSize = 20;
GLuint pickWeight = 100;

int oldX;
int oldY;

GLuint nameList1[10000];
GLuint nameList2[10000];
GLuint nameList3[10000];
GLuint nameList4[10000];
GLuint weightList1[10000];
GLuint weightList2[10000];
GLuint weightList3[10000];
GLuint weightList4[10000];


char faza = 1;
bool povratak = FALSE;

bool deformed = FALSE;


Point *meshPoints = NULL;
Point *meshPoints1 = NULL;
Point *meshPoints2 = NULL;
Point *meshPoints3 = NULL;
Point *meshPoints4 = NULL;

Triangle *meshTriangles = NULL;
Triangle *meshTriangles1 = NULL;
Triangle *meshTriangles2 = NULL;
Triangle *meshTriangles3 = NULL;
Triangle *meshTriangles4 = NULL;

Point *meshNormals = NULL; //normale svakog poligona
Point *meshNormals1 = NULL;
Point *meshNormals2 = NULL;
Point *meshNormals3 = NULL;
Point *meshNormals4 = NULL;

Point *meshVertexNormals = NULL; //normale svakog vertexa
Point *meshVertexNormals1 = NULL;
Point *meshVertexNormals2 = NULL;
Point *meshVertexNormals3 = NULL;
Point *meshVertexNormals4 = NULL;

GLuint MeshDisplayList; //display lista za iscrtavanje mesheva



//------------------------------------------
void Error(char *errString, int errNum){

	FILE *fErr = fopen("error.txt","a+");
	CTime t = CTime::GetCurrentTime();
	CString s = t.Format( "%a %d.%m.%Y." );
	CString s2 = t.Format( "%H:%M:%S" );
	fprintf(fErr,"[DATE] %s  [TIME] %s\n[ERROR] %s\n[CODE] %d\n\n", s, s2, errString, errNum);
	fclose(fErr);
}

void setOrthographicProjection() {

	// switch to projection mode
	glMatrixMode(GL_PROJECTION);
	// save previous matrix which contains the 
	//settings for the perspective projection
	glPushMatrix();
	// reset matrix
	glLoadIdentity();
	// set a 2D orthographic projection
	gluOrtho2D(0, w, 0, h);
	// invert the y axis, down is positive
	glScalef(1, -1, 1);
	// mover the origin from the bottom left corner
	// to the upper left corner
	glTranslatef(0, -h, 0);
	glMatrixMode(GL_MODELVIEW);
}
void resetPerspectiveProjection() {
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
}

void renderBitmapString(float x, float y, void *font,char *string){
char *c;

	glRasterPos2f(x, y);
	for (c = string; *c != '\0'; c++) {
		glutBitmapCharacter(font, *c);
	}
}


//izracunava normalu iz 3 tocke od trokuta
Point ComputeNormal(Point vertex1, Point vertex2, Point vertex3){

Point v1, v2, rez;
GLfloat length;
	
	v1.x = vertex1.x - vertex2.x;
	v1.y = vertex1.y - vertex2.y;
	v1.z = vertex1.z - vertex2.z;
	
	v2.x = vertex1.x - vertex3.x;
	v2.y = vertex1.y - vertex3.y;
	v2.z = vertex1.z - vertex3.z;

	rez.x = ((v1.y * v2.z) - (v1.z * v2.y));
	rez.y = ((v1.z * v2.x) - (v1.x * v2.z));
	rez.z = ((v1.x * v2.y) - (v1.y * v2.x));

	length = (float)sqrt((rez.x * rez.x) + (rez.y * rez.y) + 
					(rez.z * rez.z));

	//minus jer su vertexi poligona CW, te ce sve normale pokazivati
	//'unutra' a ne van
	rez.x /= -length;
	rez.y /= -length;
	rez.z /= -length;
	
	return rez;
}

GLvoid DrawGLScene(){

int i;
float sx, sy, ex, ey;

	//------------ PROCESS TRACKBALL ---------------------------
	if (mouseState == MOUSE_RIGHT_BUTTON_DOWN){
		sx = 2.0f * m_prerotMouse.GetX() / m_clientWindow.GetX() - 1.0f; 
		sy = 1.0f - 2.0f * m_prerotMouse.GetY() / m_clientWindow.GetY(); 
		ex = 2.0f * m_rotMouse.GetX() / m_clientWindow.GetX() - 1.0f; 
		ey = 1.0f - 2.0f * m_rotMouse.GetY() / m_clientWindow.GetY(); 

		TrackBall temp_trackball(sx, sy, ex, ey);
		m_trackBall.add_quats(temp_trackball.return_quats());
	}
	//-----------------------------------------------------------


	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	//ako smo u SELECT modu, pocinje picking
	if ((renderMode == SELECT)&&!(faza == 5)){
			StartPicking();
			DrawPickScene();
			StopPicking();
		return;
	}

	glLoadIdentity();

	//ako je pritisnut gumb RESET, resetiramo rotaciju trackballa
	//i zoom
	if (reset == 1){
		m_trackBall.init();
		reset = 0;
		zoom = -45.0f;
	}
	
	//prvo pomicemo mesheve u dubinu da stanu na ekran
	glTranslatef(0.0f, 0.0f, zoom); //za mesh.txt

	//mnozimo matricu rotacije od trackballa sa trenutnom modelview matricom
	glMultMatrixf(m_trackBall.return_matrix());
	

	
	glPushMatrix();
	glCallList(MeshDisplayList + (faza % 5));
	glPopMatrix();
        
		//ako je ukljucen wireframe flag, crtaj i wireframe
/*		if (wireframe == 1){
			glDisable(GL_LIGHTING);
			glPushMatrix();
			for (i = 0; i < nTriangles; i++){

				glBegin(GL_LINES);
	
				glColor3f(0.2f, 0.3f, 0.2f);
				glVertex3f(meshPoints[meshTriangles[i].vert1].x, 
					meshPoints[meshTriangles[i].vert1].y,
					meshPoints[meshTriangles[i].vert1].z);
				glVertex3f(meshPoints[meshTriangles[i].vert2].x, 
					meshPoints[meshTriangles[i].vert2].y,
					meshPoints[meshTriangles[i].vert2].z);
		
				glVertex3f(meshPoints[meshTriangles[i].vert2].x, 
					meshPoints[meshTriangles[i].vert2].y,
					meshPoints[meshTriangles[i].vert2].z);
				glVertex3f(meshPoints[meshTriangles[i].vert3].x, 
					meshPoints[meshTriangles[i].vert3].y,
					meshPoints[meshTriangles[i].vert3].z);
		
				glVertex3f(meshPoints[meshTriangles[i].vert3].x, 
					meshPoints[meshTriangles[i].vert3].y,
					meshPoints[meshTriangles[i].vert3].z);
				glVertex3f(meshPoints[meshTriangles[i].vert1].x, 
					meshPoints[meshTriangles[i].vert1].y,
					meshPoints[meshTriangles[i].vert1].z);
		
				glEnd();
			}	

			glPopMatrix();
			glEnable(GL_LIGHTING);
		}
*/
  


	//picking
	if (faza != 5){
		glPushMatrix();
		glDisable(GL_LIGHTING);
		glBegin(GL_POINTS);

		switch (faza) {

			case 1:
				for(i = 0; i < zadnji1; i++) {
					float selColor = (float) selWeights1[i];
					selColor /= 100;
					glColor3f(selColor, 0.0f, 0.0f);
					glVertex3f(selVertex1[i].x,selVertex1[i].y,selVertex1[i].z);
				}
				break;

			case 2:
				for(i = 0; i < zadnji2; i++) {
					float selColor = (float) selWeights2[i];
					selColor /= 100;
					glColor3f(selColor, 0.0f, 0.0f);
					glVertex3f(selVertex2[i].x, selVertex2[i].y, selVertex2[i].z);
				}
				break;

			case 3:
				for(i = 0; i < zadnji3; i++) {
					float selColor = (float) selWeights3[i];
					selColor /= 100;
					glColor3f(selColor, 0.0f, 0.0f);
					glVertex3f(selVertex3[i].x, selVertex3[i].y, selVertex3[i].z);
				}
				break;

			case 4:
				for(i = 0; i < zadnji4; i++) {
					float selColor = (float) selWeights4[i];
					selColor /= 100;
					glColor3f(selColor, 0.0f, 0.0f);
					glVertex3f(selVertex4[i].x, selVertex4[i].y, selVertex4[i].z);
				}
				break;
		}


		glEnd();
		glEnable(GL_LIGHTING);
		glPopMatrix();
	}

	//ispisujemo naredbe
	setOrthographicProjection();
	glColor3f(1.0f, 0.0f, 0.0f);
	glPushMatrix();
	glLoadIdentity();
	glDisable(GL_LIGHTING);
	renderBitmapString(15,15,(void *)GLUT_BITMAP_8_BY_13,"W - Wireframe ON/OFF");
//	renderBitmapString(15,27,(void *)GLUT_BITMAP_8_BY_13,"E - Shade NONE/FLAT/SMOOTH");
	renderBitmapString(15,51,(void *)GLUT_BITMAP_8_BY_13,"R - Reset All");
	renderBitmapString(15,39,(void *)GLUT_BITMAP_8_BY_13,"[ESC] - Reset View");
	
	renderBitmapString(15,75,(void *)GLUT_BITMAP_8_BY_13,"[ENTER] - Render");



	char fazastr[10];
	char fazachr[1];

	_itoa(faza, fazachr, 10);
	strcpy(fazastr, "\0");
	strcat(fazastr, "Faza = ");
	strcat(fazastr, fazachr);
	renderBitmapString(415,15,(void *)GLUT_BITMAP_8_BY_13, fazastr);


	char pickStr[15];
	char pickSizeStr[3];

	strcpy(pickStr, "\0");
	strcat(pickStr, "Pick Size = ");
	_itoa(pickSize, pickSizeStr, 10);
	strcat(pickStr, pickSizeStr);
	renderBitmapString(415,39,(void *)GLUT_BITMAP_8_BY_13, pickStr);


	char pickWStr[18];
	char pickWeightStr[3];

	strcpy(pickWStr, "\0");
	strcat(pickWStr, "Pick Weight Max = ");
	_itoa(pickWeight, pickWeightStr, 10);
	strcat(pickWStr, pickWeightStr);
	strcat(pickWStr, "%");
	renderBitmapString(415,51,(void *)GLUT_BITMAP_8_BY_13, pickWStr);

	
	glEnable(GL_LIGHTING);
	glPopMatrix();
	resetPerspectiveProjection();

	if (renderMode == SELECT){
		StopPicking();
	} else {
		glutSwapBuffers();
	}
	glFlush();
}


GLvoid Deform(){

int i;
GLfloat weight;
Point T1, T2, T3;

	for (i = 0; i < zadnji1; i++) {
		weight = selWeights1[i];
		weight /= 100;
		T1 = meshPoints[selPointsIndex1[i]];
		T2 = selVertex1[i];
		
		T3.x = (1 - weight)*T1.x + weight*T2.x;
		T3.y = (1 - weight)*T1.y + weight*T2.y;
		T3.z = (1 - weight)*T1.z + weight*T2.z;

		meshPoints[selPointsIndex1[i]] = T3;
	}
	for (i = 0; i < zadnji2; i++) {
//		if (selWeights2[i] > 0) selWeights2[i] = 100;
		weight = selWeights2[i];
		weight /= 100;
		T1 = meshPoints[selPointsIndex2[i]];
		T2 = selVertex2[i];
		
		T3.x = (1 - weight)*T1.x + weight*T2.x;
		T3.y = (1 - weight)*T1.y + weight*T2.y;
		T3.z = (1 - weight)*T1.z + weight*T2.z;

		meshPoints[selPointsIndex2[i]] = T3;
	}
	for (i = 0; i < zadnji3; i++) {
		weight = selWeights3[i];
		weight /= 100;
		T1 = meshPoints[selPointsIndex3[i]];
		T2 = selVertex3[i];
		
		T3.x = (1 - weight)*T1.x + weight*T2.x;
		T3.y = (1 - weight)*T1.y + weight*T2.y;
		T3.z = (1 - weight)*T1.z + weight*T2.z;

		meshPoints[selPointsIndex3[i]] = T3;
	}
	for (i = 0; i < zadnji4; i++) {
		weight = selWeights4[i];
		weight /= 100;
		T1 = meshPoints[selPointsIndex4[i]];
		T2 = selVertex4[i];
		
		T3.x = (1 - weight)*T1.x + weight*T2.x;
		T3.y = (1 - weight)*T1.y + weight*T2.y;
		T3.z = (1 - weight)*T1.z + weight*T2.z;

		meshPoints[selPointsIndex4[i]] = T3;
	}

	CalculateMeshNormals(meshPoints, nVertex, meshTriangles, nTriangles,
							meshNormals, meshVertexNormals);

	glDeleteLists(MeshDisplayList, 1);
	InitScene();

}

GLvoid DrawMesh(){

	glColor3f(yodared, yodagreen, yodablue);
	for (int i = 0; i < nTriangles; i++){
		glBegin(GL_TRIANGLES);
			
			glNormal3f(meshVertexNormals[meshTriangles[i].vert1].x, 
				meshVertexNormals[meshTriangles[i].vert1].y, 
				meshVertexNormals[meshTriangles[i].vert1].z);
			glVertex3f(meshPoints[meshTriangles[i].vert1].x, 
				meshPoints[meshTriangles[i].vert1].y,
				meshPoints[meshTriangles[i].vert1].z);
		
			glNormal3f(meshVertexNormals[meshTriangles[i].vert2].x, 
				meshVertexNormals[meshTriangles[i].vert2].y, 
				meshVertexNormals[meshTriangles[i].vert2].z);
			glVertex3f(meshPoints[meshTriangles[i].vert2].x, 
				meshPoints[meshTriangles[i].vert2].y,
				meshPoints[meshTriangles[i].vert2].z);
		
			glNormal3f(meshVertexNormals[meshTriangles[i].vert3].x, 
				meshVertexNormals[meshTriangles[i].vert3].y, 
				meshVertexNormals[meshTriangles[i].vert3].z);
			glVertex3f(meshPoints[meshTriangles[i].vert3].x, 
				meshPoints[meshTriangles[i].vert3].y,
				meshPoints[meshTriangles[i].vert3].z);
		glEnd();

	}
}

GLvoid DrawMesh1(){

	glColor3f(yodared, yodagreen, yodablue);
	for (int i = 0; i < nTriangles1; i++){
		glBegin(GL_TRIANGLES);
			
			glNormal3f(meshVertexNormals1[meshTriangles1[i].vert1].x, 
				meshVertexNormals1[meshTriangles1[i].vert1].y, 
				meshVertexNormals1[meshTriangles1[i].vert1].z);
			glVertex3f(meshPoints1[meshTriangles1[i].vert1].x, 
				meshPoints1[meshTriangles1[i].vert1].y,
				meshPoints1[meshTriangles1[i].vert1].z);
		
			glNormal3f(meshVertexNormals1[meshTriangles1[i].vert2].x, 
				meshVertexNormals1[meshTriangles1[i].vert2].y, 
				meshVertexNormals1[meshTriangles1[i].vert2].z);
			glVertex3f(meshPoints1[meshTriangles1[i].vert2].x, 
				meshPoints1[meshTriangles1[i].vert2].y,
				meshPoints1[meshTriangles1[i].vert2].z);
		
			glNormal3f(meshVertexNormals1[meshTriangles1[i].vert3].x, 
				meshVertexNormals1[meshTriangles1[i].vert3].y, 
				meshVertexNormals1[meshTriangles1[i].vert3].z);
			glVertex3f(meshPoints1[meshTriangles1[i].vert3].x, 
				meshPoints1[meshTriangles1[i].vert3].y,
				meshPoints1[meshTriangles1[i].vert3].z);
		glEnd();

	}
}

GLvoid DrawMesh2(){

	glColor3f(yodared, yodagreen, yodablue);
	for (int i = 0; i < nTriangles2; i++){
		glBegin(GL_TRIANGLES);
	
			glNormal3f(meshVertexNormals2[meshTriangles2[i].vert1].x, 
				meshVertexNormals2[meshTriangles2[i].vert1].y, 
				meshVertexNormals2[meshTriangles2[i].vert1].z);
			glVertex3f(meshPoints2[meshTriangles2[i].vert1].x, 
				meshPoints2[meshTriangles2[i].vert1].y,
				meshPoints2[meshTriangles2[i].vert1].z);
		
			glNormal3f(meshVertexNormals2[meshTriangles2[i].vert2].x, 
				meshVertexNormals2[meshTriangles2[i].vert2].y, 
				meshVertexNormals2[meshTriangles2[i].vert2].z);
			glVertex3f(meshPoints2[meshTriangles2[i].vert2].x, 
				meshPoints2[meshTriangles2[i].vert2].y,
				meshPoints2[meshTriangles2[i].vert2].z);
		
			glNormal3f(meshVertexNormals2[meshTriangles2[i].vert3].x, 
				meshVertexNormals2[meshTriangles2[i].vert3].y, 
				meshVertexNormals2[meshTriangles2[i].vert3].z);
			glVertex3f(meshPoints2[meshTriangles2[i].vert3].x, 
				meshPoints2[meshTriangles2[i].vert3].y,
				meshPoints2[meshTriangles2[i].vert3].z);
		glEnd();
	}
}

GLvoid DrawMesh3(){

	glColor3f(yodared, yodagreen, yodablue);
	for (int i = 0; i < nTriangles3; i++){
		glBegin(GL_TRIANGLES);
			
			glNormal3f(meshVertexNormals3[meshTriangles3[i].vert1].x, 
				meshVertexNormals3[meshTriangles3[i].vert1].y, 
				meshVertexNormals3[meshTriangles3[i].vert1].z);
			glVertex3f(meshPoints3[meshTriangles3[i].vert1].x, 
				meshPoints3[meshTriangles3[i].vert1].y,
				meshPoints3[meshTriangles3[i].vert1].z);
		
			glNormal3f(meshVertexNormals3[meshTriangles3[i].vert2].x, 
				meshVertexNormals3[meshTriangles3[i].vert2].y, 
				meshVertexNormals3[meshTriangles3[i].vert2].z);
			glVertex3f(meshPoints3[meshTriangles3[i].vert2].x, 
				meshPoints3[meshTriangles3[i].vert2].y,
				meshPoints3[meshTriangles3[i].vert2].z);
		
			glNormal3f(meshVertexNormals3[meshTriangles3[i].vert3].x, 
				meshVertexNormals3[meshTriangles3[i].vert3].y, 
				meshVertexNormals3[meshTriangles3[i].vert3].z);
			glVertex3f(meshPoints3[meshTriangles3[i].vert3].x, 
				meshPoints3[meshTriangles3[i].vert3].y,
				meshPoints3[meshTriangles3[i].vert3].z);
		glEnd();

	}
}

GLvoid DrawMesh4(){

	glColor3f(yodared, yodagreen, yodablue);
	for (int i = 0; i < nTriangles4; i++){
		glBegin(GL_TRIANGLES);
			
			glNormal3f(meshVertexNormals4[meshTriangles4[i].vert1].x, 
				meshVertexNormals4[meshTriangles4[i].vert1].y, 
				meshVertexNormals4[meshTriangles4[i].vert1].z);
			glVertex3f(meshPoints4[meshTriangles4[i].vert1].x, 
				meshPoints4[meshTriangles4[i].vert1].y,
				meshPoints4[meshTriangles4[i].vert1].z);
		
			glNormal3f(meshVertexNormals4[meshTriangles4[i].vert2].x, 
				meshVertexNormals4[meshTriangles4[i].vert2].y, 
				meshVertexNormals4[meshTriangles4[i].vert2].z);
			glVertex3f(meshPoints4[meshTriangles4[i].vert2].x, 
				meshPoints4[meshTriangles4[i].vert2].y,
				meshPoints4[meshTriangles4[i].vert2].z);
		
			glNormal3f(meshVertexNormals4[meshTriangles4[i].vert3].x, 
				meshVertexNormals4[meshTriangles4[i].vert3].y, 
				meshVertexNormals4[meshTriangles4[i].vert3].z);
			glVertex3f(meshPoints4[meshTriangles4[i].vert3].x, 
				meshPoints4[meshTriangles4[i].vert3].y,
				meshPoints4[meshTriangles4[i].vert3].z);
		glEnd();

	}
}



GLvoid DrawPickScene(){

	glPushMatrix();

	switch (faza) {

	case 1:
		for (int i = 0; i < nVertex1; i++){
			glPushName(i);
			glBegin(GL_POINTS);
			if (meshPoints1[i].z > 0) {
				glVertex3f(meshPoints1[i].x, meshPoints1[i].y, meshPoints1[i].z);
			}
			glEnd();
			glPopName();
		}
		break;

	case 2:
		for (int i = 0; i < nVertex2; i++){
			glPushName(i);
			glBegin(GL_POINTS);
			if (meshPoints2[i].z > 0) {
				glVertex3f(meshPoints2[i].x, meshPoints2[i].y, meshPoints2[i].z);
			}
			glEnd();
			glPopName();
		}
		break;

	case 3:
		for (int i = 0; i < nVertex3; i++){
			glPushName(i);
			glBegin(GL_POINTS);
			if (meshPoints3[i].z > 0) {
				glVertex3f(meshPoints3[i].x, meshPoints3[i].y, meshPoints3[i].z);
			}
			glEnd();
			glPopName();
		}
		break;

	case 4:
		for (int i = 0; i < nVertex4; i++){
			glPushName(i);
			glBegin(GL_POINTS);
			if (meshPoints4[i].z > 0) {
				glVertex3f(meshPoints4[i].x, meshPoints4[i].y, meshPoints4[i].z);
			}
			glEnd();
			glPopName();
		}
		break;
	}

	glPopMatrix();

}

GLvoid StartPicking(){
	GLint viewport[4];
	float ratio;

	glSelectBuffer(BUFSIZE,selectBuf);

	glGetIntegerv(GL_VIEWPORT,viewport);
	glRenderMode(GL_SELECT);
	glInitNames();

	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();
	gluPickMatrix(cursorX, viewport[3]-cursorY, pickSize, pickSize, viewport);
	ratio = (viewport[2]) / viewport[3];
	gluPerspective(45, ratio, 0.1, 100);
	glMatrixMode(GL_MODELVIEW);
		
}



//POPRAVITI!!!!!!!!!!!!! TEZINE***********
GLvoid ProcessHits (GLint hits, GLuint buffer[], int sw){
GLint i, j, k, numberOfNames;
GLuint *ptr;
bool postoji;
long indexTemp;


	switch (faza) {

		case 1:
			indexTemp = index1;
			ptr = (GLuint *) buffer;

			for (i = 0; i < hits; i++) {
				numberOfNames = *ptr;
				ptr += 3;
				for (k = 0; k < numberOfNames; k++){
					for (j = 0; j < index1; j++){
						if (nameList1[j] == *ptr) {
							postoji = true;
							weightList1[j] += 1;					
							if (weightList1[j] > pickWeight) weightList1[j] -= 3;
							break;

						} else {
							postoji = false;
						}
					}

					if (!postoji) {
						nameList1[index1] = *ptr;
						index1++;
					}
		
					ptr++;
				}
			}

			for (i = indexTemp; i < index1; i++) {
					selWeights1[zadnji1] = pickWeight;
					selVertex1[zadnji1] = meshPoints1[nameList1[i]];
					selPointsIndex1[zadnji1] = nameList1[i];
					selVertexIndex1 = nameList1[i];
					zadnji1++;
			}

			for (i = 0; i < index1; i++) {
				selWeights1[i] = weightList1[i];
			}

			break;

		case 2:
			indexTemp = index2;
			ptr = (GLuint *) buffer;

			for (i = 0; i < hits; i++) {
				numberOfNames = *ptr;
				ptr += 3;
				for (k = 0; k < numberOfNames; k++){
					for (j = 0; j < index2; j++){
						if (nameList2[j] == *ptr) {
							postoji = true;
							weightList2[j] += 1;					
							if (weightList2[j] > pickWeight) weightList2[j] -= 3;
							break;

						} else {
							postoji = false;
						}
					}

					if (!postoji) {
						nameList2[index2] = *ptr;
						index2++;
					}
		
					ptr++;
				}
			}

			for (i = indexTemp; i < index2; i++) {
					selWeights2[zadnji2] = pickWeight;
					selVertex2[zadnji2] = meshPoints2[nameList2[i]];
					selPointsIndex2[zadnji2] = nameList2[i];
					selVertexIndex2 = nameList2[i];
					zadnji2++;
			}

			for (i = 0; i < index2; i++) {
				selWeights2[i] = weightList2[i];
			}

			break;

		case 3:
			indexTemp = index3;
			ptr = (GLuint *) buffer;

			for (i = 0; i < hits; i++) {
				numberOfNames = *ptr;
				ptr += 3;
				for (k = 0; k < numberOfNames; k++){
					for (j = 0; j < index3; j++){
						if (nameList3[j] == *ptr) {
							postoji = true;
							weightList3[j] += 1;					
							if (weightList3[j] > pickWeight) weightList3[j] -= 3;
							break;

						} else {
							postoji = false;
						}
					}

					if (!postoji) {
						nameList3[index3] = *ptr;
						index3++;
					}
		
					ptr++;
				}
			}

			for (i = indexTemp; i < index3; i++) {
					selWeights3[zadnji3] = pickWeight;
					selVertex3[zadnji3] = meshPoints3[nameList3[i]];
					selPointsIndex3[zadnji3] = nameList3[i];
					selVertexIndex3 = nameList3[i];
					zadnji3++;
			}

			for (i = 0; i < index3; i++) {
				selWeights3[i] = weightList3[i];
			}

			break;

		case 4:
			indexTemp = index4;
			ptr = (GLuint *) buffer;

			for (i = 0; i < hits; i++) {
				numberOfNames = *ptr;
				ptr += 3;
				for (k = 0; k < numberOfNames; k++){
					for (j = 0; j < index4; j++){
						if (nameList4[j] == *ptr) {
							postoji = true;
							weightList4[j] += 1;					
							if (weightList4[j] > pickWeight) weightList4[j] -= 3;
							break;

						} else {
							postoji = false;
						}
					}

					if (!postoji) {
						nameList4[index4] = *ptr;
						index4++;
					}
		
					ptr++;
				}
			}

			for (i = indexTemp; i < index4; i++) {
					selWeights4[zadnji4] = pickWeight;
					selVertex4[zadnji4] = meshPoints4[nameList4[i]];
					selPointsIndex4[zadnji4] = nameList4[i];
					selVertexIndex4 = nameList4[i];
					zadnji4++;
			}

			for (i = 0; i < index4; i++) {
				selWeights4[i] = weightList4[i];
			}

			break;


	} //switch

}

GLvoid StopPicking() {

	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
	glFlush();
	hits = glRenderMode(GL_RENDER);
	if (hits != 0){
		ProcessHits(hits, selectBuf, 0);
	}
	renderMode = RENDER;
}



GLvoid InitScene(){
	
	MeshDisplayList = glGenLists(5);

	glNewList(MeshDisplayList, GL_COMPILE);
		DrawMesh();
	glEndList();

	glNewList(MeshDisplayList+1, GL_COMPILE);
		DrawMesh1();
	glEndList();

	glNewList(MeshDisplayList+2, GL_COMPILE);
		DrawMesh2();
	glEndList();

	glNewList(MeshDisplayList+3, GL_COMPILE);
		DrawMesh3();
	glEndList();

	glNewList(MeshDisplayList+4, GL_COMPILE);
		DrawMesh4();
	glEndList();

	
}

GLvoid ReshapeWindow(GLint width, GLint height){

	if (height == 0) height = 1;
	
	w = width; h = height;
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
//	glViewport(0, 0, width, height);
	GLUI_Master.auto_set_viewport();
	gluPerspective(45.0f, (GLfloat)width / (GLfloat)height, 0.1f, 100.0f);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	m_clientWindow.Set( width, height );

}




GLvoid ProcessKey(unsigned char key, int x, int y){


	if (key == 'w'){
		FILE *fof;	
		int i;

		fof = fopen("out.head","w");

		fprintf(fof,"%d\n", nVertex);

		for(i=0; i<nVertex; i++){
			fprintf(fof,"%f %f %f\n", meshPoints[i].x, meshPoints[i].y, meshPoints[i].z);
		}

		fprintf(fof,"%d\n", nTriangles);

		for(i=0; i<nTriangles; i++){
			fprintf(fof,"%d %d %d\n", meshTriangles[i].vert1, meshTriangles[i].vert2, meshTriangles[i].vert3);
		}

		fclose(fof);
	}

	if (key == 27){ // esc
		reset = 1;
	}

	if (key == 13){ // enter
		
		if (deformed) {
			deformed = FALSE;
		} else {
			Deform();
			deformed = TRUE;
		}
	}

	if (key == 'r'){
		reset = 1;

		selVertexIndex1 = 0;
		selVertexIndex2 = 0;
		selVertexIndex3 = 0;
		selVertexIndex4 = 0;
		zadnji1 = 0;
		zadnji2 = 0;
		zadnji3 = 0;
		zadnji4 = 0;
		faza = 1;
		index1 = 0;
		index2 = 0;
		index3 = 0;
		index4 = 0;
	}

	if (key == 'm'){
		zoom += 1;
	}

	if (key == 'n'){
		zoom -= 1;
	}

	if (key == 't'){
//		ConvertMesh("default.head");
	}


	if (key == 'q'){
		Cleanup();
		exit(0);
	}

}

GLvoid ProcessSpecialKey(int key, int x, int y){

	switch(key){

		case GLUT_KEY_RIGHT:
			if (faza < FAZE) faza += 1;
			break;

		case GLUT_KEY_LEFT:
			if (faza > 1) {
				faza -= 1;
				povratak = TRUE;
				break;
			}
			break;

		case GLUT_KEY_PAGE_UP:
			if (pickWeight < 125) {
				pickWeight += 25;
			}
			break;

		case GLUT_KEY_PAGE_DOWN:
			if (pickWeight > 10) {
				pickWeight -= 25;
			}
			break;

		case GLUT_KEY_INSERT:
			pickSize += 1;
			break;

		case GLUT_KEY_HOME:
			if (pickSize > 5) {
				pickSize -= 1;
			}
			break;

	}
}


GLvoid ProcessMouse(int button, int state, int x, int y){

	if (state == GLUT_DOWN){
		if (button == GLUT_RIGHT_BUTTON){
			mouseState = MOUSE_RIGHT_BUTTON_DOWN;
			glutSetCursor( GLUT_CURSOR_INFO );
			m_rotMouse.Set( x, y );
			m_prerotMouse = m_rotMouse;
			oldX = x;
			oldY = y;
		} else if (button == GLUT_MIDDLE_BUTTON){
		
			} else { 
				mouseState = MOUSE_LEFT_BUTTON_DOWN;
				glutSetCursor( GLUT_CURSOR_LEFT_ARROW );
				cursorX = x;
				cursorY = y;
				renderMode = SELECT;
			}
	} else {

		glutSetCursor( GLUT_CURSOR_LEFT_ARROW );
		mouseState = MOUSE_CLEAR;
	}
}


GLvoid ProcessMouseActiveMotion(int x, int y){
	
	
	if(mouseState == MOUSE_RIGHT_BUTTON_DOWN){	

		glutSetCursor( GLUT_CURSOR_INFO );
		m_prerotMouse = m_rotMouse;
		m_rotMouse.Set(x, y );
		oldX = x;
		oldY = y;

	}else{
		cursorX = x;
		cursorY = y;
		renderMode = SELECT;
	}

}



GLvoid MyGlutIdle(){

	glutSetWindow(glutWnd1);
	glutPostRedisplay();

}


GLvoid InitGLut(int argc, char *argv[]){

	
	glutInit(&argc, argv);

	glutInitWindowPosition(50, 50);
	glutInitWindowSize(600, 600);
	glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_DEPTH);
	glutWnd1 = glutCreateWindow("Preobrazba Izraza Lica");
	
	glutDisplayFunc(DrawGLScene);

	GLUI_Master.set_glutKeyboardFunc(ProcessKey);
	GLUI_Master.set_glutSpecialFunc(ProcessSpecialKey);
	GLUI_Master.set_glutMouseFunc(ProcessMouse);
	glutMotionFunc(ProcessMouseActiveMotion);
//	GLUI_Master.set_glutIdleFunc(ProcessIdle);
	GLUI_Master.set_glutReshapeFunc(ReshapeWindow);

//da bi glui mogao koristiti idle eventove	
	GLUI_Master.set_glutIdleFunc(MyGlutIdle);

}



GLvoid InitGL(){

int i;



	glEnable(GL_TEXTURE_2D); //teksture!	
//	glShadeModel(GL_SMOOTH); //smooth shading, a ne flat, sada odredjeno sa shade flagom
	glClearColor(0.2f, 0.2f, 0.2f, 0.0f); //crna za brisanje

	glClearDepth(1.0f);	//na koliko resetiramo depth buffer
	glEnable(GL_DEPTH_TEST); //ukljuci Z_buffer
	glDepthFunc(GL_LEQUAL); //podesi rad Z_buffera
	
//	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
	
	glCullFace(GL_BACK);//backface culling
	glEnable(GL_CULL_FACE);

	glLightfv(GL_LIGHT1, GL_AMBIENT, AmbientLight);
	glLightfv(GL_LIGHT1, GL_POSITION, LightPosition);
	glLightfv(GL_LIGHT1, GL_DIFFUSE, DiffuseLight);
	glEnable(GL_LIGHT1);
	glEnable(GL_LIGHTING);

	glColorMaterial(GL_FRONT, GL_DIFFUSE);
	glEnable(GL_COLOR_MATERIAL); 

	//poligoni su CW a openGL uzima po defaultu CCW
	glFrontFace(GL_CW);
	glEnable(GL_NORMALIZE);

	glPointSize(5);//velicina tocaka kod iscrtavanja

	for (i = 0; i < 10000; i++) weightList1[i] = 0;
	for (i = 0; i < 10000; i++) weightList2[i] = 0;
	for (i = 0; i < 10000; i++) weightList3[i] = 0;
	for (i = 0; i < 10000; i++) weightList4[i] = 0;

////////////////////7

//	CAVIGenerator AviGen();

//	BYTE				*bmBits;
//	LPBITMAPINFOHEADER	lpbih = AviGen.GetBitmapHeader(); // getting bitmap info
//
//	bmBits=new BYTE[3 * lpbih->biWidth* lpbih->biHeight];

//	glReadPixels(0,0,lpbih->biWidth,lpbih->biHeight,GL_BGR_EXT,GL_UNSIGNED_BYTE,bmBits);


}

GLvoid Cleanup(){

	if (meshPoints != NULL)	delete [] meshPoints;
	if (meshTriangles != NULL) delete [] meshTriangles;
	if (meshNormals != NULL) delete [] meshNormals;
	if (meshVertexNormals != NULL) delete [] meshVertexNormals;
	if (meshPoints2 != NULL)	delete [] meshPoints2;
	if (meshTriangles2 != NULL) delete [] meshTriangles2;
	if (meshNormals2 != NULL) delete [] meshNormals2;
	if (meshVertexNormals2 != NULL) delete [] meshVertexNormals2;
	
	glDeleteLists(MeshDisplayList, 5);
	
	GLUI_Master.close_all();

}


GLvoid ReadString(FILE *fp, char *string){

	do{
		fgets(string, 255, fp);
	} while(string[0] == '/' || string[0] == '\n');

	return;
}


GLvoid CalculateMeshNormals(Point vertexList[], GLint nVert, Triangle triangleList[],
							GLint nTri, Point normalList[], Point vertNormalList[]){
int i;
GLint *nPolys = NULL;


	nPolys = new int[nVert];
								
	for (i = 0; i < nVert; i++){
		vertNormalList[i].x = 0;
		vertNormalList[i].y = 0;
		vertNormalList[i].z = 0;
		nPolys[i] = 0;
	}
	
	for (i = 0; i < nTri; i++){
		normalList[i] = ComputeNormal(vertexList[triangleList[i].vert1],
				vertexList[triangleList[i].vert2],
				vertexList[triangleList[i].vert3]);
			
		vertNormalList[triangleList[i].vert1].x += normalList[i].x;
		vertNormalList[triangleList[i].vert1].y += normalList[i].y;
		vertNormalList[triangleList[i].vert1].z += normalList[i].z;
		
		vertNormalList[triangleList[i].vert2].x += normalList[i].x;
		vertNormalList[triangleList[i].vert2].y += normalList[i].y;
		vertNormalList[triangleList[i].vert2].z += normalList[i].z;
		
		vertNormalList[triangleList[i].vert3].x += normalList[i].x;
		vertNormalList[triangleList[i].vert3].y += normalList[i].y;
		vertNormalList[triangleList[i].vert3].z += normalList[i].z;
		
		nPolys[triangleList[i].vert1]++;
		nPolys[triangleList[i].vert2]++;
		nPolys[triangleList[i].vert3]++;
	}
	
	for (i = 0; i < nVert; i++){
		vertNormalList[i].x /= nPolys[i];
		vertNormalList[i].y /= nPolys[i];
		vertNormalList[i].z /= nPolys[i];
	}
	
	if (nPolys != NULL) delete [] nPolys;
}

GLint LoadMesh(char *file, char *file1, char *file2, char *file3, char *file4){

FILE *fMesh, *fMesh1, *fMesh2, *fMesh3, *fMesh4;
char inString[255];
GLint i;
	
	if((fMesh = fopen(file, "r")) == NULL){
		Error("Could not open Mesh default file!", 0);
		return 0;
	}
	
	if((fMesh1 = fopen(file1, "r")) == NULL){
		Error("Could not open Mesh file1!", 0);
		return 0;
	}
	
	if((fMesh2 = fopen(file2, "r")) == NULL){
		Error("Could not open Mesh file2!", 0);
		return 0;
	}
		
	if((fMesh3 = fopen(file3, "r")) == NULL){
		Error("Could not open Mesh file3!", 0);
		return 0;
	}

	if((fMesh4 = fopen(file4, "r")) == NULL){
		Error("Could not open Mesh file4!", 0);
		return 0;
	}
	
	
	ReadString(fMesh, inString);
	sscanf(inString, "%d", &nVertex);

	ReadString(fMesh1, inString);
	sscanf(inString, "%d", &nVertex1);

	ReadString(fMesh2, inString);
	sscanf(inString, "%d", &nVertex2);

	ReadString(fMesh3, inString);
	sscanf(inString, "%d", &nVertex3);

	ReadString(fMesh4, inString);
	sscanf(inString, "%d", &nVertex4);



	meshPoints = new Point[nVertex];
	meshPoints1 = new Point[nVertex1];
	meshPoints2 = new Point[nVertex2];
	meshPoints3 = new Point[nVertex3];
	meshPoints4 = new Point[nVertex4];

	for (i = 0; i < nVertex; i++){
		ReadString(fMesh, inString);
		sscanf(inString, "%f %f %f", &meshPoints[i].x,
									 &meshPoints[i].y, 
									 &meshPoints[i].z);
	}
	for (i = 0; i < nVertex1; i++){
		ReadString(fMesh1, inString);
		sscanf(inString, "%f %f %f", &meshPoints1[i].x,
									 &meshPoints1[i].y, 
									 &meshPoints1[i].z);
	}
	for (i = 0; i < nVertex2; i++){
		ReadString(fMesh2, inString);
		sscanf(inString, "%f %f %f", &meshPoints2[i].x,
									 &meshPoints2[i].y, 
									 &meshPoints2[i].z);
	}
	for (i = 0; i < nVertex3; i++){
		ReadString(fMesh3, inString);
		sscanf(inString, "%f %f %f", &meshPoints3[i].x,
									 &meshPoints3[i].y, 
									 &meshPoints3[i].z);
	}
	for (i = 0; i < nVertex4; i++){
		ReadString(fMesh4, inString);
		sscanf(inString, "%f %f %f", &meshPoints4[i].x,
									 &meshPoints4[i].y, 
									 &meshPoints4[i].z);
	}


	ReadString(fMesh, inString);
	sscanf(inString, "%d", &nTriangles);

	ReadString(fMesh1, inString);
	sscanf(inString, "%d", &nTriangles1);

	ReadString(fMesh2, inString);
	sscanf(inString, "%d", &nTriangles2);

	ReadString(fMesh3, inString);
	sscanf(inString, "%d", &nTriangles3);

	ReadString(fMesh4, inString);
	sscanf(inString, "%d", &nTriangles4);

	meshTriangles = new Triangle[nTriangles];
	meshTriangles1 = new Triangle[nTriangles1];
	meshTriangles2 = new Triangle[nTriangles2];
	meshTriangles3 = new Triangle[nTriangles3];
	meshTriangles4 = new Triangle[nTriangles4];

	meshNormals = new Point[nTriangles];
	meshVertexNormals = new Point[nVertex];

	meshNormals1 = new Point[nTriangles1];
	meshVertexNormals1 = new Point[nVertex1];

	meshNormals2 = new Point[nTriangles2];
	meshVertexNormals2 = new Point[nVertex2];

	meshNormals3 = new Point[nTriangles3];
	meshVertexNormals3 = new Point[nVertex3];

	meshNormals4 = new Point[nTriangles4];
	meshVertexNormals4 = new Point[nVertex4];


	for (i = 0; i < nTriangles; i++){
		ReadString(fMesh, inString);
		sscanf(inString, "%d %d %d", &meshTriangles[i].vert1,
									 &meshTriangles[i].vert2, 
									 &meshTriangles[i].vert3);
	}
    
	for (i = 0; i < nTriangles1; i++){
		ReadString(fMesh1, inString);
		sscanf(inString, "%d %d %d", &meshTriangles1[i].vert1,
									 &meshTriangles1[i].vert2, 
									 &meshTriangles1[i].vert3);
	}
	
	for (i = 0; i < nTriangles2; i++){
		ReadString(fMesh2, inString);
		sscanf(inString, "%d %d %d", &meshTriangles2[i].vert1,
									 &meshTriangles2[i].vert2, 
									 &meshTriangles2[i].vert3);
	}

	for (i = 0; i < nTriangles3; i++){
		ReadString(fMesh3, inString);
		sscanf(inString, "%d %d %d", &meshTriangles3[i].vert1,
									 &meshTriangles3[i].vert2, 
									 &meshTriangles3[i].vert3);
	}
		
	for (i = 0; i < nTriangles4; i++){
		ReadString(fMesh4, inString);
		sscanf(inString, "%d %d %d", &meshTriangles4[i].vert1,
									 &meshTriangles4[i].vert2, 
									 &meshTriangles4[i].vert3);
	}
	
	CalculateMeshNormals(meshPoints, nVertex, meshTriangles, nTriangles,
							meshNormals, meshVertexNormals);

	CalculateMeshNormals(meshPoints1, nVertex1, meshTriangles1, nTriangles1,
							meshNormals1, meshVertexNormals1);

	CalculateMeshNormals(meshPoints2, nVertex2, meshTriangles2, nTriangles2,
							meshNormals2, meshVertexNormals2);

	CalculateMeshNormals(meshPoints3, nVertex3, meshTriangles3, nTriangles3,
							meshNormals3, meshVertexNormals3);

	CalculateMeshNormals(meshPoints4, nVertex4, meshTriangles4, nTriangles4,
							meshNormals4, meshVertexNormals4);



	fclose (fMesh);
	fclose (fMesh1);
	fclose (fMesh2);
	fclose (fMesh3);
	fclose (fMesh4);

	return 1;

}

/*
//konverta u wavefront .obj fajl

int ConvertMesh(char *file){
FILE *fMesh, *fOut;
Point point, *meshPoints;
Triangle *meshTriangles;
int i, nTriangles, vert1, vert2, vert3;
char inString[255];

	if((fMesh = fopen(file, "r")) == NULL){
		Error("Could not open Mesh file", 0);
		return 0;
	}

	
	if((fOut = fopen("mesh.TRIA", "w")) == NULL){
		Error("Could not open Mesh outfile", 0);
		return 0;
	}


	ReadString(fMesh, inString);
	sscanf(inString, "%d", &nVertex);
	meshPoints = new Point[nVertex];


	for (i = 0; i < nVertex; i++){
		ReadString(fMesh, inString);
		sscanf(inString, "%f %f %f", &meshPoints[i].x, &meshPoints[i].y, &meshPoints[i].z);
	}




	ReadString(fMesh, inString);
	sscanf(inString, "%d", &nTriangles);
	meshTriangles = new Triangle[nTriangles];

//	fprintf(fOut, "%d %d\n", nVertex, nTriangles); //header .TRIA file

	for (i = 0; i < nVertex; i++){
		fprintf(fOut, "v %f %f %f\n", meshPoints[i].x, meshPoints[i].y, meshPoints[i].z);
	}


/*	for (i = 0; i < nTriangles; i++){
		ReadString(fMesh, inString);
		sscanf(inString, "%d %d %d", &vert1, 
									 &vert2, 
									 &vert3);

		fprintf(fOut, "%d %d %d\n", vert1, 
								   vert2, 
								   vert3);
	}
* /		
	
	
//	nTriangles=2;
	for (i = 0; i < nTriangles; i++){
		ReadString(fMesh, inString);
		sscanf(inString, "%d %d %d", &meshTriangles[i].vert1, 
									 &meshTriangles[i].vert2, 
									 &meshTriangles[i].vert3);


/*		fprintf(fOut,"v %f %f %f\n", meshPoints[meshTriangles[i].vert1].x,
									 meshPoints[meshTriangles[i].vert1].y,
									 meshPoints[meshTriangles[i].vert1].z);		
		
		fprintf(fOut,"v %f %f %f\n", meshPoints[meshTriangles[i].vert2].x,
									 meshPoints[meshTriangles[i].vert2].y,
									 meshPoints[meshTriangles[i].vert2].z);		
		
		fprintf(fOut,"v %f %f %f\n", meshPoints[meshTriangles[i].vert3].x,
									 meshPoints[meshTriangles[i].vert3].y,
									 meshPoints[meshTriangles[i].vert3].z);
* /
//		fprintf(fOut, "f %1 %2 %3\n\n");
		fprintf(fOut, "f %d %d %d\n\n", meshTriangles[i].vert1 +1, 
										meshTriangles[i].vert2 +1, 
										meshTriangles[i].vert3 +1);

	}

	


	fclose(fMesh);
	fclose(fOut);
}

*/




///////////////////////////////////////////////////////////////////////////
int main(int argc, char *argv[]){

	if (LoadMesh("glave\\yoda_neut.head", 
				 "glave\\yoda_ljut.head", 
				 "glave\\yoda_sretan.head",
				 "glave\\yoda_strah.head",
				 "glave\\yoda_iznen.head") == 0){
		return 0;
	}

	InitGLut(argc, argv);
	InitGL();
	InitScene();
	
	for(;;){
		glutCheckLoop();
	}

	Cleanup();
	return 1;
}
